Index: src/test/java/org/apache/camel/processor/aggregator/AggregatorExceptionTest.java
===================================================================
--- src/test/java/org/apache/camel/processor/aggregator/AggregatorExceptionTest.java	(revision 0)
+++ src/test/java/org/apache/camel/processor/aggregator/AggregatorExceptionTest.java	(revision 0)
@@ -0,0 +1,75 @@
+/**
+ * Licensed to the Apache Software Foundation (ASF) under one or more
+ * contributor license agreements.  See the NOTICE file distributed with
+ * this work for additional information regarding copyright ownership.
+ * The ASF licenses this file to You under the Apache License, Version 2.0
+ * (the "License"); you may not use this file except in compliance with
+ * the License.  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.apache.camel.processor.aggregator;
+
+import org.apache.camel.CamelException;
+import org.apache.camel.ContextTestSupport;
+import org.apache.camel.Exchange;
+import org.apache.camel.Processor;
+import org.apache.camel.builder.RouteBuilder;
+import org.apache.camel.component.mock.MockEndpoint;
+import org.apache.camel.model.LoggingLevel;
+import org.apache.camel.processor.aggregate.AggregationStrategy;
+import org.apache.camel.processor.aggregate.PredicateAggregationCollection;
+
+/**
+ * Unit test inspired by user forum.
+ */
+public class AggregatorExceptionTest extends ContextTestSupport {
+
+    public void testAggregateAndOnException() throws Exception {
+        //MockEndpoint mock = getMockEndpoint("mock:result");
+        //mock.expectedBodiesReceived("Bye World");
+
+        //template.sendBodyAndHeader("seda:start", "Hello World", "id", 123);
+        for (;;) {
+            template.sendBodyAndHeader("direct:start", "Hi!", "id", 123);
+        }
+        //assertMockEndpointsSatisfied();
+    }
+
+    @Override
+    protected RouteBuilder createRouteBuilder() throws Exception {
+        return new RouteBuilder() {
+            @Override
+            public void configure() throws Exception {
+
+                byte b[] = new byte[10];
+                for (int c = 0; c < b.length; c++) {
+                    b[c] = '_';
+                }
+
+                final String exceptionString = new String(b);
+
+                errorHandler(loggingErrorHandler("ERROR_HANDLER").level(LoggingLevel.WARN));
+
+                onException(java.lang.RuntimeException.class).to("log:EXCEPTION");
+                //onException(java.lang.NoSuchMethodError.class).to("log:EXCEPTION");
+
+                from("direct:start")
+                    .aggregator(header("id"))
+                    .batchSize(10)
+                    .batchTimeout(500L)
+                    .process(new Processor() {
+                        public void process(Exchange exchange) throws Exception {
+                            throw new java.lang.NoSuchMethodError(exceptionString);   
+                        }
+                    });
+            }
+        };
+    }
+}
Index: src/test/resources/log4j.properties
===================================================================
--- src/test/resources/log4j.properties	(revision 906078)
+++ src/test/resources/log4j.properties	(working copy)
@@ -21,7 +21,7 @@
 log4j.rootLogger=INFO, out
 
 log4j.logger.org.apache.activemq.spring=WARN
-#log4j.logger.org.apache.camel=DEBUG
+log4j.logger.org.apache.camel=DEBUG
 log4j.logger.org.apache.camel.impl.converter=WARN
 
 # CONSOLE appender not used by default
Index: pom.xml
===================================================================
--- pom.xml	(revision 906078)
+++ pom.xml	(working copy)
@@ -138,7 +138,8 @@
       <plugin>
         <artifactId>maven-surefire-plugin</artifactId>
         <configuration>
-          <forkMode>pertest</forkMode>
+            <forkMode>pertest</forkMode>
+            <argLine>-XX:+HeapDumpOnOutOfMemoryError</argLine>
           <excludes>
             <!-- TODO FIXME ASAP -->
             <exclude>**/XXXTest.*</exclude>