Index: testsuite/src/test/java/org/jboss/ejb3/test/entity/Company.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/entity/Company.java	(revision 114645)
+++ testsuite/src/test/java/org/jboss/ejb3/test/entity/Company.java	(working copy)
@@ -44,7 +44,7 @@
    private Set<Flight> flights;
 
    @Id
-   @GeneratedValue(strategy= GenerationType.AUTO)
+//   @GeneratedValue(strategy= GenerationType.AUTO)
    public Integer getId()
    {
       return id;
Index: testsuite/src/test/java/org/jboss/ejb3/test/entity/EntityTestBean.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/entity/EntityTestBean.java	(revision 114645)
+++ testsuite/src/test/java/org/jboss/ejb3/test/entity/EntityTestBean.java	(working copy)
@@ -62,7 +62,31 @@
    private @JndiInject(jndiName="java:/TransactionManager") TransactionManager tm;
    private static Log log = LogFactory.getLog( "org.hibernate.ejb" );
 
-
+   public FieldFlight createFieldFlight(final long fieldFlighID, final String fieldFlightName, final int fieldCompanyID, final String fieldCompanyName)
+   {
+      final FieldFlight fieldFlight = new FieldFlight();
+      fieldFlight.setId(fieldFlighID);
+      fieldFlight.setName(fieldFlightName);
+      final FieldCompany company = new FieldCompany();
+      company.setName(fieldCompanyName);
+      company.setId(fieldCompanyID);
+      fieldFlight.setCompany(company);
+      manager.persist(fieldFlight);
+      return fieldFlight;
+   }
+   
+   public Flight createFlight(long flightId, String flightName, int companyId, String companyName) throws Exception {
+        Flight flight = new Flight();
+        flight.setId(new Long(flightId));
+        flight.setName(flightName);
+        Company company = new Company();
+        company.setId(new Integer(companyId));
+        company.setName(companyName);
+        flight.setCompany(company);
+        manager.persist(flight);
+        return flight;
+   }
+   
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    public void testOutsideTransaction()
    {
@@ -113,31 +137,18 @@
 
    public Flight manyToOneCreate() throws Exception
    {
-      Flight firstOne = new Flight();
-      firstOne.setId(new Long(1));
-      firstOne.setName("AF0101");
-      Company frenchOne = new Company();
-      frenchOne.setName("Air France");
-      firstOne.setCompany(frenchOne);
-      manager.persist(firstOne);
-      return firstOne;
+      return createFlight(1l,"AF0101",1,"Air France");
    }
 
    public void manyToManyCreate() throws Exception
    {
 
-      Flight firstOne = findFlightById(new Long(1));
-      Flight second = new Flight();
-      second.setId(new Long(2));
-      second.setName("US1");
-      Company us = new Company();
-      us.setName("USAir");
-      second.setCompany(us);
-
+      Flight firstOne = this.createFlight(2, "AF0103", 2,"Air France Aliance");
+      Flight second = this.createFlight(3, "US", 3,"USAir");
+      
       Set<Customer> customers1 = new HashSet<Customer>();
       Set<Customer> customers2 = new HashSet<Customer>();
 
-
       Customer bill = new Customer();
       bill.setName("Bill");
       customers1.add(bill);
@@ -195,26 +206,14 @@
 
    public FieldFlight fieldManyToOneCreate() throws Exception
    {
-      FieldFlight firstOne = new FieldFlight();
-      firstOne.setId(new Long(1));
-      firstOne.setName("AF0101");
-      FieldCompany frenchOne = new FieldCompany();
-      frenchOne.setName("Air France");
-      firstOne.setCompany(frenchOne);
-      manager.persist(firstOne);
-      return firstOne;
+      return this.createFieldFlight(1l, "AF0101",1, "Air France");
    }
 
    public void fieldManyToManyCreate() throws Exception
    {
 
-      FieldFlight firstOne = fieldFindFlightById(new Long(1));
-      FieldFlight second = new FieldFlight();
-      second.setId(new Long(2));
-      second.setName("US1");
-      FieldCompany us = new FieldCompany();
-      us.setName("USAir");
-      second.setCompany(us);
+      FieldFlight firstOne = createFieldFlight(3, "KL800", 3, "KLM");
+      FieldFlight second = createFieldFlight(2, "US1", 2, "USAir");
 
       Set<FieldCustomer> customers1 = new HashSet<FieldCustomer>();
       Set<FieldCustomer> customers2 = new HashSet<FieldCustomer>();
Index: testsuite/src/test/java/org/jboss/ejb3/test/entity/FieldCompany.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/entity/FieldCompany.java	(revision 114645)
+++ testsuite/src/test/java/org/jboss/ejb3/test/entity/FieldCompany.java	(working copy)
@@ -39,7 +39,7 @@
 @Entity
 public class FieldCompany implements java.io.Serializable
 {
-   @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
+   @Id
    private Integer id;
 
    private String name;
Index: testsuite/src/test/java/org/jboss/ejb3/test/entity/Flight.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/entity/Flight.java	(revision 114645)
+++ testsuite/src/test/java/org/jboss/ejb3/test/entity/Flight.java	(working copy)
@@ -61,7 +61,7 @@
    Set<Customer> customers;
 
    @Id
-   @GeneratedValue(strategy=GenerationType.TABLE, generator = "default-generator")
+//   @GeneratedValue(strategy=GenerationType.TABLE, generator = "default-generator")
    public Long getId()
    {
       return id;
Index: testsuite/src/test/java/org/jboss/ejb3/test/entity/unit/EntityUnitTestCase.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/entity/unit/EntityUnitTestCase.java	(revision 114645)
+++ testsuite/src/test/java/org/jboss/ejb3/test/entity/unit/EntityUnitTestCase.java	(working copy)
@@ -98,25 +98,12 @@
       EntityTest test = (EntityTest) this.getInitialContext().lookup("EntityTestBean/remote");
       test.manyToManyCreate();
 
-      Flight one = test.findFlightById(new Long(1));
-      assertTrue(one.getCompany().getName().equals("Air France"));
+      Flight one = test.findFlightById(new Long(2));
+      assertTrue(one.getCompany().getName().equals("Air France Aliance"));
 
-      Flight two = test.findFlightById(new Long(2));
+      Flight two = test.findFlightById(new Long(3));
       assertTrue(two.getCompany().getName().equals("USAir"));
 
-      System.out.println("Air France customers");
-      for (Customer c : one.getCustomers())
-      {
-         System.out.println(c.getName());
-
-      }
-      System.out.println("USAir customers");
-
-      for (Customer c : two.getCustomers())
-      {
-         System.out.println(c.getName());
-      }
-
    }
 
    public void testFieldOneToMany() throws Exception